package org.dromara.common.translation.core.impl;

import com.hotwj.platform.common.mapper.PublicMapper;
import lombok.AllArgsConstructor;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.translation.annotation.TranslationType;
import org.dromara.common.translation.constant.TransConstant;
import org.dromara.common.translation.core.TranslationInterface;

/**
 * 区域编码翻译实现类
 *
 * @author shihongewi
 */
@AllArgsConstructor
@TranslationType(type = TransConstant.REGION_CODE_TO_NAME)
public class RegionCodeTranslationImpl implements TranslationInterface<String> {

    private final PublicMapper publicMapper;

    // 考虑支持逗号分割的情况
    @Override
    public String translation(Object key, String other) {
        if (key instanceof String regionCode && StringUtils.isNotBlank(regionCode)) {
            // 不是6位区划代码，直接返回空串
            if (StringUtils.length(regionCode) != 6) {
                return "";
            }
            // 使用单SQL透视，一次性获取 省 市 区 全名
            return publicMapper.selectRegionFullNameByCode(regionCode);
        }
        return null;
    }
}
